import 'package:built_collection/built_collection.dart';
import 'package:rxdart/rxdart.dart';

extension ListBuilderExt<T> on ListBuilder<T> {
  void removeWhereNull() => removeWhere((value) => value == null);
}

extension SubjectBuiltMapExt<K, V> on Subject<BuiltMap<K, V>> {
  Future<void> rebuild(void updates(MapBuilder<K, V> builder)) async {
    final oldMap = await first;
    add(oldMap.rebuild(updates));
  }
}

extension SubjectBuiltListExt<V> on Subject<BuiltList<V>> {
  Future<void> rebuild(void updates(ListBuilder<V> builder)) async {
    final oldMap = await first;
    add(oldMap.rebuild(updates));
  }

//  Future<void> putIfAbsent(K key, V creator()) async {
//    final oldMap = await first;
//    if (!oldMap.containsKey(key)) add(oldMap.rebuild((builder) => builder[key] = creator()));
//  }
}
